diff --git a/src/common/slurmdb_defs.c b/src/common/slurmdb_defs.c
index f4f606b66b..35e812742e 100644
--- a/src/common/slurmdb_defs.c
+++ b/src/common/slurmdb_defs.c
@@ -3042,6 +3042,7 @@ extern int slurmdb_send_accounting_update(List update_list, char *cluster,
 	slurm_set_addr_char(&req.address, port, host);
 
 	req.protocol_version = rpc_version;
+	slurm_msg_set_r_uid(&req, SLURM_AUTH_UID_ANY);
 
 	req.msg_type = ACCOUNTING_UPDATE_MSG;
 	if (slurmdbd_conf)
diff --git a/src/common/stepd_api.c b/src/common/stepd_api.c
index ed385e5c11..ef80af2cd1 100644
--- a/src/common/stepd_api.c
+++ b/src/common/stepd_api.c
@@ -523,7 +523,7 @@ rwfail:
 int
 stepd_attach(int fd, uint16_t protocol_version,
 	     slurm_addr_t *ioaddr, slurm_addr_t *respaddr,
-	     void *job_cred_sig, reattach_tasks_response_msg_t *resp)
+	     void *job_cred_sig, uid_t uid, reattach_tasks_response_msg_t *resp)
 {
 	int req = REQUEST_ATTACH;
 	int rc = SLURM_SUCCESS;
@@ -533,6 +533,7 @@ stepd_attach(int fd, uint16_t protocol_version,
 		safe_write(fd, ioaddr, sizeof(slurm_addr_t));
 		safe_write(fd, respaddr, sizeof(slurm_addr_t));
 		safe_write(fd, job_cred_sig, SLURM_IO_KEY_SIZE);
+		safe_write(fd, &uid, sizeof(uid_t));
 		safe_write(fd, &protocol_version, sizeof(uint16_t));
 	} else
 		goto rwfail;
diff --git a/src/common/stepd_api.h b/src/common/stepd_api.h
index 425a42fec5..137fadd3df 100644
--- a/src/common/stepd_api.h
+++ b/src/common/stepd_api.h
@@ -200,7 +200,8 @@ int stepd_signal_container(int fd, uint16_t protocol_version, int signal,
  */
 int stepd_attach(int fd, uint16_t protocol_version,
 		 slurm_addr_t *ioaddr, slurm_addr_t *respaddr,
-		 void *job_cred_sig, reattach_tasks_response_msg_t *resp);
+		 void *job_cred_sig, uid_t uid,
+		 reattach_tasks_response_msg_t *resp);
 
 /*
  * Scan for available running slurm step daemons by checking
diff --git a/src/plugins/accounting_storage/common/common_as.c b/src/plugins/accounting_storage/common/common_as.c
index 73d90144e0..e3311e30e6 100644
--- a/src/plugins/accounting_storage/common/common_as.c
+++ b/src/plugins/accounting_storage/common/common_as.c
@@ -396,6 +396,7 @@ extern int cluster_first_reg(char *host, uint16_t port, uint16_t rpc_version)
 		out_msg.msg_type = ACCOUNTING_FIRST_REG;
 		out_msg.flags = SLURM_GLOBAL_AUTH_KEY;
 		out_msg.data = &update;
+		slurm_msg_set_r_uid(&out_msg, SLURM_AUTH_UID_ANY);
 		slurm_send_node_msg(fd, &out_msg);
 		/* We probably need to add matching recv_msg function
 		 * for an arbitray fd or should these be fire
diff --git a/src/plugins/accounting_storage/slurmdbd/dbd_conn.c b/src/plugins/accounting_storage/slurmdbd/dbd_conn.c
new file mode 100644
index 0000000000..c9672a732f
--- /dev/null
+++ b/src/plugins/accounting_storage/slurmdbd/dbd_conn.c
@@ -0,0 +1,380 @@
+/****************************************************************************\
+ *  dbd_conn.c - functions to manage the connection to the SlurmDBD
+ *****************************************************************************
+ *  Copyright (C) 2011-2020 SchedMD LLC.
+ *  Copyright (C) 2008-2010 Lawrence Livermore National Security.
+ *  Produced at Lawrence Livermore National Laboratory (cf, DISCLAIMER).
+ *  Written by Danny Auble <da@schedmd.com>
+ *  Written by Morris Jette <jette1@llnl.gov>
+ *  CODE-OCEC-09-009. All rights reserved.
+ *
+ *  This file is part of Slurm, a resource management program.
+ *  For details, see <https://slurm.schedmd.com/>.
+ *  Please also read the included file: DISCLAIMER.
+ *
+ *  Slurm is free software; you can redistribute it and/or modify it under
+ *  the terms of the GNU General Public License as published by the Free
+ *  Software Foundation; either version 2 of the License, or (at your option)
+ *  any later version.
+ *
+ *  In addition, as a special exception, the copyright holders give permission
+ *  to link the code of portions of this program with the OpenSSL library under
+ *  certain conditions as described in each individual source file, and
+ *  distribute linked combinations including the two. You must obey the GNU
+ *  General Public License in all respects for all of the code used other than
+ *  OpenSSL. If you modify file(s) with this exception, you may extend this
+ *  exception to your version of the file(s), but you are not obligated to do
+ *  so. If you do not wish to do so, delete this exception statement from your
+ *  version.  If you delete this exception statement from all source files in
+ *  the program, then also delete it here.
+ *
+ *  Slurm is distributed in the hope that it will be useful, but WITHOUT ANY
+ *  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+ *  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+ *  details.
+ *
+ *  You should have received a copy of the GNU General Public License along
+ *  with Slurm; if not, write to the Free Software Foundation, Inc.,
+ *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA.
+\*****************************************************************************/
+
+#include "src/common/slurm_xlator.h"
+#include "src/common/slurmdbd_pack.h"
+#include "src/slurmctld/trigger_mgr.h"
+#include "slurmdbd_agent.h"
+
+#define SLURMDBD_TIMEOUT	900	/* Seconds SlurmDBD for response */
+
+static void _acct_full(void)
+{
+	if (running_in_slurmctld())
+		trigger_primary_ctld_acct_full();
+}
+
+static void _dbd_fail(void)
+{
+	if (running_in_slurmctld())
+		trigger_primary_dbd_fail();
+}
+
+static void _dbd_res_op(void)
+{
+	if (running_in_slurmctld())
+		trigger_primary_dbd_res_op();
+}
+
+static void _db_fail(void)
+{
+	if (running_in_slurmctld())
+		trigger_primary_db_fail();
+}
+
+static void _db_res_op(void)
+{
+	if (running_in_slurmctld())
+		trigger_primary_db_res_op();
+}
+
+static int _connect_dbd_conn(slurm_persist_conn_t *pc)
+{
+
+	int rc;
+	char *backup_host = NULL;
+
+	xassert(pc);
+
+	/* Only setup a backup host on a non ext_dbd connection */
+	if (!(pc->flags & PERSIST_FLAG_EXT_DBD))
+		backup_host =
+			xstrdup(slurm_conf.accounting_storage_backup_host);
+again:
+	// A connection failure is only an error if backup dne or also fails
+	if (backup_host)
+		pc->flags |= PERSIST_FLAG_SUPPRESS_ERR;
+	else
+		pc->flags &= (~PERSIST_FLAG_SUPPRESS_ERR);
+
+	pc->r_uid = SLURM_AUTH_UID_ANY;
+
+	if (((rc = slurm_persist_conn_open(pc)) != SLURM_SUCCESS) &&
+	    backup_host) {
+		xfree(pc->rem_host);
+		// Force the next error to display
+		pc->comm_fail_time = 0;
+		pc->rem_host = backup_host;
+		backup_host = NULL;
+		goto again;
+	}
+
+	xfree(backup_host);
+
+	if (rc == SLURM_SUCCESS) {
+		/*
+		 * Increase SLURMDBD_TIMEOUT to wait as long as we need for a
+		 * query to complete.
+		 */
+		pc->timeout = MAX(pc->timeout, SLURMDBD_TIMEOUT * 1000);
+		(pc->trigger_callbacks.dbd_resumed)();
+		(pc->trigger_callbacks.db_resumed)();
+	}
+
+	if (rc == SLURM_SUCCESS) {
+		debug("Sent PersistInit msg");
+		/* clear errno (checked after this for errors) */
+		errno = 0;
+	} else {
+		if (rc == ESLURM_DB_CONNECTION)
+			(pc->trigger_callbacks.db_fail)();
+		slurm_persist_conn_close(pc);
+
+		/* This means errno was already set correctly */
+		if (rc != SLURM_ERROR)
+			errno = rc;
+		error("Sending PersistInit msg: %m");
+	}
+
+	return rc;
+}
+
+extern slurm_persist_conn_t *dbd_conn_open(uint16_t *persist_conn_flags,
+					   char *cluster_name,
+					   char *rem_host,
+					   uint16_t rem_port)
+{
+	slurm_persist_conn_t *pc = xmalloc(sizeof(*pc));
+
+	if (persist_conn_flags)
+		pc->flags = *persist_conn_flags;
+	pc->flags |= (PERSIST_FLAG_DBD | PERSIST_FLAG_RECONNECT);
+	pc->persist_type = PERSIST_TYPE_DBD;
+	if (cluster_name)
+		pc->cluster_name = xstrdup(cluster_name);
+	else
+		pc->cluster_name = xstrdup(slurm_conf.cluster_name);
+	pc->timeout = (slurm_conf.msg_timeout + 35) * 1000;
+	if (rem_host)
+		pc->rem_host = xstrdup(rem_host);
+	else
+		pc->rem_host = xstrdup(slurm_conf.accounting_storage_host);
+	if (rem_port)
+		pc->rem_port = rem_port;
+	else
+		pc->rem_port = slurm_conf.accounting_storage_port;
+	pc->version = SLURM_PROTOCOL_VERSION;
+
+	/* Initialize the callback pointers */
+	pc->trigger_callbacks.acct_full = _acct_full;
+	pc->trigger_callbacks.dbd_fail = _dbd_fail;
+	pc->trigger_callbacks.dbd_resumed = _dbd_res_op;
+	pc->trigger_callbacks.db_fail = _db_fail;
+	pc->trigger_callbacks.db_resumed = _db_res_op;
+
+	(void)_connect_dbd_conn(pc);
+
+	if (persist_conn_flags)
+		*persist_conn_flags = pc->flags;
+
+	return pc;
+}
+
+extern int dbd_conn_check_and_reopen(slurm_persist_conn_t *pc)
+{
+	xassert(pc);
+
+	if (pc && pc->fd >= 0) {
+		debug("Attempt to re-open slurmdbd socket");
+		/* clear errno (checked after this for errors) */
+		errno = 0;
+		return SLURM_SUCCESS;
+	}
+
+	/*
+	 * Reset the rem_host just in case we were connected to the backup
+	 * before.
+	 */
+	xfree(pc->rem_host);
+	pc->rem_host = xstrdup(slurm_conf.accounting_storage_host);
+
+	return _connect_dbd_conn(pc);
+}
+
+extern void dbd_conn_close(slurm_persist_conn_t **pc)
+{
+	int rc;
+	Buf buffer;
+	dbd_fini_msg_t req;
+
+	if (!pc)
+		return;
+
+	/*
+	 * Only send the FINI message if we haven't shutdown
+	 * (i.e. not slurmctld)
+	 */
+	if (*(*pc)->shutdown) {
+		log_flag(NET, "We are shutdown, not sending DB_FINI to %s:%u",
+			 (*pc)->rem_host,
+			 (*pc)->rem_port);
+		return;
+	}
+
+	/* If the connection is already gone, we don't need to send a fini. */
+	if (slurm_persist_conn_writeable(*pc) == -1) {
+		log_flag(NET, "unable to send DB_FINI msg to %s:%u",
+			 (*pc)->rem_host,
+			 (*pc)->rem_port);
+		return;
+	}
+
+	buffer = init_buf(1024);
+	pack16((uint16_t) DBD_FINI, buffer);
+	req.commit = 0;
+	req.close_conn = 1;
+	slurmdbd_pack_fini_msg(&req, SLURM_PROTOCOL_VERSION, buffer);
+
+	rc = slurm_persist_send_msg(*pc, buffer);
+	free_buf(buffer);
+
+	log_flag(NET, "sent DB_FINI msg to %s:%u rc(%d):%s",
+		 (*pc)->rem_host, (*pc)->rem_port,
+		 rc, slurm_strerror(rc));
+
+	slurm_persist_conn_destroy(*pc);
+	*pc = NULL;
+}
+
+/*
+ * Send an RPC to the SlurmDBD and wait for an arbitrary reply message.
+ * The RPC will not be queued if an error occurs.
+ * The "resp" message must be freed by the caller.
+ * Returns SLURM_SUCCESS or an error code
+ */
+extern int dbd_conn_send_recv_direct(uint16_t rpc_version,
+				     persist_msg_t *req,
+				     persist_msg_t *resp)
+{
+	int rc = SLURM_SUCCESS;
+	Buf buffer;
+	slurm_persist_conn_t *use_conn = req->conn;
+
+	xassert(req);
+	xassert(resp);
+	xassert(use_conn);
+
+	if (use_conn->fd < 0) {
+		/* The connection has been closed, reopen */
+		rc = dbd_conn_check_and_reopen(use_conn);
+
+		if (rc != SLURM_SUCCESS || (use_conn->fd < 0)) {
+			rc = SLURM_ERROR;
+			goto end_it;
+		}
+	}
+
+	if (!(buffer = pack_slurmdbd_msg(req, rpc_version))) {
+		rc = SLURM_ERROR;
+		goto end_it;
+	}
+
+	rc = slurm_persist_send_msg(use_conn, buffer);
+	free_buf(buffer);
+	if (rc != SLURM_SUCCESS) {
+		error("Sending message type %s: %d: %s",
+		      slurmdbd_msg_type_2_str(req->msg_type, 1), rc,
+		      slurm_strerror(rc));
+		goto end_it;
+	}
+
+	buffer = slurm_persist_recv_msg(use_conn);
+	if (buffer == NULL) {
+		error("Getting response to message type: %s",
+		      slurmdbd_msg_type_2_str(req->msg_type, 1));
+		rc = SLURM_ERROR;
+		goto end_it;
+	}
+
+	rc = unpack_slurmdbd_msg(resp, rpc_version, buffer);
+	/* check for the rc of the start job message */
+	if (rc == SLURM_SUCCESS && resp->msg_type == DBD_ID_RC)
+		rc = ((dbd_id_rc_msg_t *)resp->data)->return_code;
+
+	free_buf(buffer);
+end_it:
+
+	log_flag(PROTOCOL, "msg_type:%s protocol_version:%hu return_code:%d response_msg_type:%s",
+		 slurmdbd_msg_type_2_str(req->msg_type, 1),
+		 rpc_version, rc, slurmdbd_msg_type_2_str(resp->msg_type, 1));
+
+	return rc;
+}
+
+extern int dbd_conn_send_recv_rc_msg(uint16_t rpc_version,
+				     persist_msg_t *req,
+				     int *resp_code)
+{
+	int rc;
+	persist_msg_t resp;
+
+	xassert(req);
+	xassert(resp_code);
+
+	memset(&resp, 0, sizeof(persist_msg_t));
+	rc = dbd_conn_send_recv(rpc_version, req, &resp);
+	if (rc != SLURM_SUCCESS) {
+		;	/* error message already sent */
+	} else if (resp.msg_type != PERSIST_RC) {
+		error("response is not type PERSIST_RC: %s(%u)",
+		      slurmdbd_msg_type_2_str(resp.msg_type, 1),
+		      resp.msg_type);
+		rc = SLURM_ERROR;
+	} else {	/* resp.msg_type == PERSIST_RC */
+		persist_rc_msg_t *msg = resp.data;
+		*resp_code = msg->rc;
+		if (msg->rc != SLURM_SUCCESS &&
+		    msg->rc != ACCOUNTING_FIRST_REG &&
+		    msg->rc != ACCOUNTING_TRES_CHANGE_DB &&
+		    msg->rc != ACCOUNTING_NODES_CHANGE_DB) {
+			char *comment = msg->comment;
+			if (!comment)
+				comment = slurm_strerror(msg->rc);
+			if (!req->conn &&
+			    (msg->ret_info == DBD_REGISTER_CTLD) &&
+			    slurm_conf.accounting_storage_enforce) {
+				error("Issue with call "
+				      "%s(%u): %u(%s)",
+				      slurmdbd_msg_type_2_str(
+					      msg->ret_info, 1),
+				      msg->ret_info, msg->rc,
+				      comment);
+				fatal("You need to add this cluster "
+				      "to accounting if you want to "
+				      "enforce associations, or no "
+				      "jobs will ever run.");
+			} else
+				debug("Issue with call "
+				      "%s(%u): %u(%s)",
+				      slurmdbd_msg_type_2_str(
+					      msg->ret_info, 1),
+				      msg->ret_info, msg->rc,
+				      comment);
+		}
+		slurm_persist_free_rc_msg(msg);
+	}
+
+	log_flag(PROTOCOL, "msg_type:%s protocol_version:%hu return_code:%d",
+		 slurmdbd_msg_type_2_str(req->msg_type, 1),
+		 rpc_version, rc);
+
+	return rc;
+}
+
+extern int dbd_conn_send_recv(uint16_t rpc_version,
+			      persist_msg_t *req,
+			      persist_msg_t *resp)
+{
+	if (running_in_slurmctld() &&
+	    (!req->conn || (req->conn == slurmdbd_conn)))
+		return slurmdbd_agent_send_recv(rpc_version, req, resp);
+	else
+		return dbd_conn_send_recv_direct(rpc_version, req, resp);
+}
diff --git a/src/plugins/auth/jwt/auth_jwt.c b/src/plugins/auth/jwt/auth_jwt.c
index 6eab3be5f0..aeb1e3e652 100644
--- a/src/plugins/auth/jwt/auth_jwt.c
+++ b/src/plugins/auth/jwt/auth_jwt.c
@@ -75,6 +75,7 @@ const char plugin_name[] = "JWT authentication plugin";
 const char plugin_type[] = "auth/jwt";
 const uint32_t plugin_id = AUTH_PLUGIN_JWT;
 const uint32_t plugin_version   = SLURM_VERSION_NUMBER;
+bool hash_enable = false;
 
 typedef struct {
 	int index; /* MUST ALWAYS BE FIRST. DO NOT PACK. */
@@ -149,7 +150,8 @@ extern int fini(void)
 	return SLURM_SUCCESS;
 }
 
-auth_token_t *slurm_auth_create(char *auth_info)
+auth_token_t *slurm_auth_create(char *auth_info, uid_t r_uid,
+				void *data, int dlen)
 {
 	return xmalloc(sizeof(auth_token_t));
 }
@@ -306,6 +308,18 @@ char *slurm_auth_get_host(auth_token_t *cred)
 	return NULL;
 }
 
+int auth_p_get_data(auth_token_t *cred, char **data, uint32_t *len)
+{
+	if (cred == NULL) {
+		slurm_seterrno(ESLURM_AUTH_BADARG);
+		return SLURM_ERROR;
+	}
+
+	*data = NULL;
+	*len = 0;
+	return SLURM_SUCCESS;
+}
+
 int slurm_auth_pack(auth_token_t *cred, Buf buf, uint16_t protocol_version)
 {
 	char *pack_this = (thread_token) ? thread_token : token;
diff --git a/src/plugins/auth/munge/auth_munge.c b/src/plugins/auth/munge/auth_munge.c
index 789119b2f9..3361f74156 100644
--- a/src/plugins/auth/munge/auth_munge.c
+++ b/src/plugins/auth/munge/auth_munge.c
@@ -85,6 +85,7 @@ const char plugin_name[] = "Munge authentication plugin";
 const char plugin_type[] = "auth/munge";
 const uint32_t plugin_id = AUTH_PLUGIN_MUNGE;
 const uint32_t plugin_version = SLURM_VERSION_NUMBER;
+bool hash_enable = true;
 
 static int bad_cred_test = -1;
 
@@ -102,6 +103,8 @@ typedef struct _slurm_auth_credential {
 	bool    verified;  /* true if this cred has been verified            */
 	uid_t   uid;       /* UID. valid only if verified == true            */
 	gid_t   gid;       /* GID. valid only if verified == true            */
+	void *data;	/* payload data		*/
+	int dlen;	/* payload data length	*/
 } slurm_auth_credential_t;
 
 /* Static prototypes */
@@ -130,7 +133,8 @@ int init(void)
  * allocate a credential.  Whether the credential is populated with useful
  * data at this time is implementation-dependent.
  */
-slurm_auth_credential_t *slurm_auth_create(char *opts)
+slurm_auth_credential_t *slurm_auth_create(char *opts, uid_t r_uid,
+					   void *data, int dlen)
 {
 	int rc, retry = RETRY_COUNT, auth_ttl;
 	slurm_auth_credential_t *cred = NULL;
@@ -155,6 +159,13 @@ slurm_auth_credential_t *slurm_auth_create(char *opts)
 		}
 	}
 
+	rc = munge_ctx_set(ctx, MUNGE_OPT_UID_RESTRICTION, r_uid);
+	if (rc != EMUNGE_SUCCESS) {
+		error("munge_ctx_set failure");
+		munge_ctx_destroy(ctx);
+		return NULL;
+	}
+
 	auth_ttl = slurm_get_auth_ttl();
 	if (auth_ttl)
 		(void) munge_ctx_set(ctx, MUNGE_OPT_TTL, auth_ttl);
@@ -162,6 +173,8 @@ slurm_auth_credential_t *slurm_auth_create(char *opts)
 	cred = xmalloc(sizeof(*cred));
 	cred->verified = false;
 	cred->m_str    = NULL;
+	cred->data = NULL;
+	cred->dlen = 0;
 
 	xassert((cred->magic = MUNGE_MAGIC));
 
@@ -174,7 +187,7 @@ slurm_auth_credential_t *slurm_auth_create(char *opts)
 	ohandler = xsignal(SIGALRM, (SigFunc *)SIG_BLOCK);
 
 again:
-	err = munge_encode(&cred->m_str, ctx, NULL, 0);
+	err = munge_encode(&cred->m_str, ctx, data, dlen);
 	if (err != EMUNGE_SUCCESS) {
 		if ((err == EMUNGE_SOCKET) && retry--) {
 			debug("Munge encode failed: %s (retrying ...)",
@@ -215,6 +228,8 @@ int slurm_auth_destroy(slurm_auth_credential_t *cred)
 	/* Note: Munge cred string not encoded with xmalloc() */
 	if (cred->m_str)
 		free(cred->m_str);
+	if (cred->data)
+		free(cred->data);
 
 	xfree(cred);
 	return SLURM_SUCCESS;
@@ -336,6 +351,34 @@ char *slurm_auth_get_host(slurm_auth_credential_t *cred)
 	return hostname;
 }
 
+/*
+ * auth_p_verify() must be called first.
+ */
+int auth_p_get_data(slurm_auth_credential_t *cred, char **data, uint32_t *len)
+{
+	if (!cred || !cred->verified) {
+		/*
+		 * This xassert will trigger on a development build if
+		 * the calling path did not verify the credential first.
+		 */
+		xassert(!cred);
+		slurm_seterrno(ESLURM_AUTH_BADARG);
+		return SLURM_ERROR;
+	}
+
+	xassert(cred->magic == MUNGE_MAGIC);
+
+	if (cred->data && cred->dlen) {
+		*data = xmalloc(cred->dlen);
+		memcpy(*data, cred->data, cred->dlen);
+		*len = cred->dlen;
+	} else {
+		*data = NULL;
+		*len = 0;
+	}
+	return SLURM_SUCCESS;
+}
+
 /*
  * Marshall a credential for transmission over the network, according to
  * Slurm's marshalling protocol.
@@ -428,7 +471,7 @@ static int _decode_cred(slurm_auth_credential_t *c, char *socket)
 	}
 
 again:
-	err = munge_decode(c->m_str, ctx, NULL, NULL, &c->uid, &c->gid);
+	err = munge_decode(c->m_str, ctx, &c->data, &c->dlen, &c->uid, &c->gid);
 	if (err != EMUNGE_SUCCESS) {
 		if ((err == EMUNGE_SOCKET) && retry--) {
 			debug("Munge decode failed: %s (retrying ...)",
diff --git a/src/plugins/auth/none/auth_none.c b/src/plugins/auth/none/auth_none.c
index 321377da53..19f4331829 100644
--- a/src/plugins/auth/none/auth_none.c
+++ b/src/plugins/auth/none/auth_none.c
@@ -75,6 +75,7 @@ const char plugin_name[] = "Null authentication plugin";
 const char plugin_type[] = "auth/none";
 const uint32_t plugin_id = AUTH_PLUGIN_NONE;
 const uint32_t plugin_version = SLURM_VERSION_NUMBER;
+bool hash_enable = false;
 
 /*
  * An opaque type representing authentication credentials.  This type can be
@@ -138,7 +139,8 @@ extern int fini(void)
  * Allocate and initializes a credential.  This function should return
  * NULL if it cannot allocate a credential.
  */
-slurm_auth_credential_t *slurm_auth_create(char *auth_info)
+slurm_auth_credential_t *slurm_auth_create(char *auth_info, uid_t r_uid,
+					   void *data, int dlen)
 {
 	slurm_auth_credential_t *cred = xmalloc(sizeof(*cred));
 
@@ -217,6 +219,19 @@ char *slurm_auth_get_host(slurm_auth_credential_t *cred)
 	return xstrdup(cred->hostname);
 }
 
+int auth_p_get_data(slurm_auth_credential_t *cred, char **data, uint32_t *len)
+{
+	if (!cred) {
+		slurm_seterrno(ESLURM_AUTH_BADARG);
+		return SLURM_ERROR;
+	}
+
+	*data = NULL;
+	*len = 0;
+
+	return SLURM_SUCCESS;
+}
+
 /*
  * Marshall a credential for transmission over the network, according to
  * Slurm's marshalling protocol.
diff --git a/src/plugins/mpi/pmi2/setup.c b/src/plugins/mpi/pmi2/setup.c
index 3dd074f0af..116c5f25fe 100644
--- a/src/plugins/mpi/pmi2/setup.c
+++ b/src/plugins/mpi/pmi2/setup.c
@@ -106,6 +106,8 @@ _setup_stepd_job_info(const stepd_step_rec_t *job, char ***env)
 
 	memset(&job_info, 0, sizeof(job_info));
 
+	job_info.uid = job->uid;
+
 	if (job->het_job_id && (job->het_job_id != NO_VAL)) {
 		job_info.jobid  = job->het_job_id;
 		job_info.stepid = job->stepid;
diff --git a/src/plugins/mpi/pmi2/setup.h b/src/plugins/mpi/pmi2/setup.h
index 6f25d372e7..e329b5d215 100644
--- a/src/plugins/mpi/pmi2/setup.h
+++ b/src/plugins/mpi/pmi2/setup.h
@@ -59,6 +59,7 @@
 typedef struct pmi2_job_info {
 	uint32_t jobid;  /* Current Slurm job id                      */
 	uint32_t stepid; /* Current step id (or NO_VAL)               */
+	uid_t uid;       /* user id for job */
 	uint32_t nnodes; /* number of nodes in current job step       */
 	uint32_t nodeid; /* relative position of this node in job     */
 	uint32_t ntasks; /* total number of tasks in current job      */
diff --git a/src/plugins/mpi/pmi2/spawn.c b/src/plugins/mpi/pmi2/spawn.c
index 50ea79027c..182edae3e4 100644
--- a/src/plugins/mpi/pmi2/spawn.c
+++ b/src/plugins/mpi/pmi2/spawn.c
@@ -151,7 +151,8 @@ spawn_req_pack(spawn_req_t *req, Buf buf)
 	void *auth_cred;
 	char *auth_info = slurm_get_auth_info();
 
-	auth_cred = g_slurm_auth_create(AUTH_DEFAULT_INDEX, auth_info);
+	auth_cred = g_slurm_auth_create(AUTH_DEFAULT_INDEX, slurm_conf.authinfo,
+					job_info.uid, NULL, 0);
 	xfree(auth_info);
 	if (auth_cred == NULL) {
 		error("authentication: %m");
@@ -214,6 +215,7 @@ spawn_req_unpack(spawn_req_t **req_ptr, Buf buf)
 	if (g_slurm_auth_verify(auth_cred, auth_info)) {
 		error("authentication: %m");
 		xfree(auth_info);
+		g_slurm_auth_destroy(auth_cred);
 		return SLURM_ERROR;
 	}
 	xfree(auth_info);
diff --git a/src/plugins/mpi/pmix/pmixp_dconn.c b/src/plugins/mpi/pmix/pmixp_dconn.c
index e8524a8ce3..594230bfc1 100644
--- a/src/plugins/mpi/pmix/pmixp_dconn.c
+++ b/src/plugins/mpi/pmix/pmixp_dconn.c
@@ -79,6 +79,7 @@ int pmixp_dconn_init(int node_cnt, pmixp_p2p_data_t direct_hdr)
 		_pmixp_dconn_conns[i].nodeid = i;
 		_pmixp_dconn_conns[i].state = PMIXP_DIRECT_INIT;
 		_pmixp_dconn_conns[i].priv = _pmixp_dconn_h.init(i, direct_hdr);
+		_pmixp_dconn_conns[i].uid = slurm_conf.slurmd_user_id;
 	}
 	return SLURM_SUCCESS;
 }
diff --git a/src/plugins/mpi/pmix/pmixp_dconn.h b/src/plugins/mpi/pmix/pmixp_dconn.h
index 77f302f103..7e34fbdad2 100644
--- a/src/plugins/mpi/pmix/pmixp_dconn.h
+++ b/src/plugins/mpi/pmix/pmixp_dconn.h
@@ -82,6 +82,9 @@ typedef struct {
 	/* remote node info */
 	int nodeid;
 	void *priv;
+
+	/* authenticated uid on remote */
+	uid_t uid;
 } pmixp_dconn_t;
 
 typedef void *(*pmixp_dconn_p2p_init_t)(int nodeid,
diff --git a/src/plugins/mpi/pmix/pmixp_server.c b/src/plugins/mpi/pmix/pmixp_server.c
index 20c1b17f9e..4ced93c14b 100644
--- a/src/plugins/mpi/pmix/pmixp_server.c
+++ b/src/plugins/mpi/pmix/pmixp_server.c
@@ -494,13 +494,14 @@ void pmixp_server_cleanup(void)
  * --------------------- Authentication functionality -------------------
  */
 
-static int _auth_cred_create(Buf buf)
+static int _auth_cred_create(Buf buf, uid_t uid)
 {
 	void *auth_cred = NULL;
 	char *auth_info = slurm_get_auth_info();
 	int rc = SLURM_SUCCESS;
 
-	auth_cred = g_slurm_auth_create(AUTH_DEFAULT_INDEX, auth_info);
+	auth_cred = g_slurm_auth_create(AUTH_DEFAULT_INDEX, slurm_conf.authinfo,
+					uid, NULL, 0);
 	xfree(auth_info);
 	if (!auth_cred) {
 		PMIXP_ERROR("Creating authentication credential: %m");
@@ -520,7 +521,7 @@ static int _auth_cred_create(Buf buf)
 	return rc;
 }
 
-static int _auth_cred_verify(Buf buf)
+static int _auth_cred_verify(Buf buf, uid_t *uid)
 {
 	void *auth_cred = NULL;
 	char *auth_info = NULL;
@@ -540,8 +541,18 @@ static int _auth_cred_verify(Buf buf)
 	rc = g_slurm_auth_verify(auth_cred, auth_info);
 	xfree(auth_info);
 
-	if (rc)
+	if (rc) {
 		PMIXP_ERROR("Verifying authentication credential: %m");
+	} else {
+		uid_t auth_uid;
+		auth_uid = g_slurm_auth_get_uid(auth_cred);
+		if ((auth_uid != slurm_conf.slurmd_user_id) &&
+		    (auth_uid != _pmixp_job_info.uid)) {
+			PMIXP_ERROR("Credential from uid %u", auth_uid);
+			rc = SLURM_ERROR;
+		}
+		*uid = auth_uid;
+	}
 	g_slurm_auth_destroy(auth_cred);
 	return rc;
 }
@@ -708,7 +719,7 @@ static int _process_extended_hdr(pmixp_base_hdr_t *hdr, Buf buf)
 		pmixp_base_hdr_t bhdr;
 		init_msg = xmalloc(sizeof(*init_msg));
 
-		rc = _auth_cred_create(buf_init);
+		rc = _auth_cred_create(buf_init, dconn->uid);
 		if (rc) {
 			FREE_NULL_BUFFER(init_msg->buf_ptr);
 			xfree(init_msg);
@@ -1162,6 +1173,7 @@ _direct_conn_establish(pmixp_conn_t *conn, void *_hdr, void *msg)
 	Buf buf_msg;
 	int rc;
 	char *nodename = NULL;
+	uid_t uid = SLURM_AUTH_NOBODY;
 
 	if (!hdr->ext_flag) {
 		nodename = pmixp_info_job_host(hdr->nodeid);
@@ -1185,7 +1197,7 @@ _direct_conn_establish(pmixp_conn_t *conn, void *_hdr, void *msg)
 		return;
 	}
 	/* Unpack and verify the auth credential */
-	rc = _auth_cred_verify(buf_msg);
+	rc = _auth_cred_verify(buf_msg, &uid);
 	FREE_NULL_BUFFER(buf_msg);
 	if (rc) {
 		close(fd);
@@ -1209,6 +1221,9 @@ _direct_conn_establish(pmixp_conn_t *conn, void *_hdr, void *msg)
 		xfree(nodename);
 		return;
 	}
+
+	dconn->uid = uid;
+
 	new_conn = pmixp_conn_new_persist(PMIXP_PROTO_DIRECT,
 					  pmixp_dconn_engine(dconn),
 					  _direct_new_msg_conn,
diff --git a/src/plugins/mpi/pmix/pmixp_utils.c b/src/plugins/mpi/pmix/pmixp_utils.c
index 3d1c56847c..5d22cacf83 100644
--- a/src/plugins/mpi/pmix/pmixp_utils.c
+++ b/src/plugins/mpi/pmix/pmixp_utils.c
@@ -418,6 +418,7 @@ static int _pmix_p2p_send_core(const char *nodename, const char *address,
 	msg.forward.timeout = timeout;
 	msg.forward.cnt = 0;
 	msg.forward.nodelist = NULL;
+	slurm_msg_set_r_uid(&msg, slurm_conf.slurmd_user_id);
 	ret_list = slurm_send_addr_recv_msgs(&msg, (char*)nodename, timeout);
 	if (!ret_list) {
 		/* This should never happen (when this was
diff --git a/src/sattach/sattach.c b/src/sattach/sattach.c
index 8870db653e..948f1156d3 100644
--- a/src/sattach/sattach.c
+++ b/src/sattach/sattach.c
@@ -405,6 +405,7 @@ static int _attach_to_tasks(uint32_t jobid,
 	reattach_msg.io_port = io_ports;
 	reattach_msg.cred = fake_cred;
 
+	slurm_msg_set_r_uid(&msg, SLURM_AUTH_UID_ANY);
 	msg.msg_type = REQUEST_REATTACH_TASKS;
 	msg.data = &reattach_msg;
 	msg.protocol_version = layout->start_protocol_ver;
diff --git a/src/slurmctld/agent.c b/src/slurmctld/agent.c
index ec557308ac..cebc4cf158 100644
--- a/src/slurmctld/agent.c
+++ b/src/slurmctld/agent.c
@@ -144,6 +144,7 @@ typedef struct agent_info {
 	uint16_t retry;			/* if set, keep trying */
 	thd_t *thread_struct;		/* thread structures */
 	bool get_reply;			/* flag if reply expected */
+	uid_t r_uid;			/* receiver UID */
 	slurm_msg_type_t msg_type;	/* RPC to be issued */
 	void **msg_args_pptr;		/* RPC data to be used */
 	uint16_t protocol_version;	/* if set, use this version */
@@ -157,6 +158,7 @@ typedef struct task_info {
 	uint32_t *threads_active_ptr;	/* currently active thread ptr */
 	thd_t *thread_struct_ptr;	/* thread structures ptr */
 	bool get_reply;			/* flag if reply expected */
+	uid_t r_uid;			/* receiver UID */
 	slurm_msg_type_t msg_type;	/* RPC to be issued */
 	void *msg_args_ptr;		/* ptr to RPC data to be used */
 	uint16_t protocol_version;	/* if set, use this version */
@@ -316,14 +318,16 @@ void *agent(void *args)
 	slurm_thread_create(&thread_wdog, _wdog, agent_info_ptr);
 
 	if (slurmctld_conf.debug_flags & DEBUG_FLAG_AGENT) {
-		info("%s: New agent thread_count:%d threads_active:%d retry:%c get_reply:%c msg_type:%s protocol_version:%hu",
+		info("%s: New agent thread_count:%d threads_active:%d retry:%c get_reply:%c r_uid:%u msg_type:%s protocol_version:%hu",
 		     __func__, agent_info_ptr->thread_count,
 		     agent_info_ptr->threads_active,
 		     agent_info_ptr->retry ? 'T' : 'F',
 		     agent_info_ptr->get_reply ? 'T' : 'F',
+		     agent_info_ptr->r_uid,
 		     rpc_num2string(agent_arg_ptr->msg_type),
 		     agent_info_ptr->protocol_version);
 	}
+
 	/* start all the other threads (up to AGENT_THREAD_COUNT active) */
 	for (i = 0; i < agent_info_ptr->thread_count; i++) {
 		/* wait until "room" for another thread */
@@ -421,6 +425,11 @@ static int _valid_agent_arg(agent_arg_t *agent_arg_ptr)
 		     __func__, agent_arg_ptr->node_count, hostlist_cnt);
 		return SLURM_ERROR;	/* no messages to be sent */
 	}
+	if (!agent_arg_ptr->r_uid_set) {
+		error("%s: r_uid not set for message:%u ",
+		      __func__, agent_arg_ptr->msg_type);
+		return SLURM_ERROR;
+	}
 	return SLURM_SUCCESS;
 }
 
@@ -443,6 +452,7 @@ static agent_info_t *_make_agent_info(agent_arg_t *agent_arg_ptr)
 	thread_ptr = xcalloc(agent_info_ptr->thread_count, sizeof(thd_t));
 	memset(thread_ptr, 0, (agent_info_ptr->thread_count * sizeof(thd_t)));
 	agent_info_ptr->thread_struct  = thread_ptr;
+	agent_info_ptr->r_uid = agent_arg_ptr->r_uid;
 	agent_info_ptr->msg_type       = agent_arg_ptr->msg_type;
 	agent_info_ptr->msg_args_pptr  = &agent_arg_ptr->msg_args;
 	agent_info_ptr->protocol_version = agent_arg_ptr->protocol_version;
@@ -529,6 +539,7 @@ static task_info_t *_make_task_data(agent_info_t *agent_info_ptr, int inx)
 	task_info_ptr->threads_active_ptr= &agent_info_ptr->threads_active;
 	task_info_ptr->thread_struct_ptr = &agent_info_ptr->thread_struct[inx];
 	task_info_ptr->get_reply         = agent_info_ptr->get_reply;
+	task_info_ptr->r_uid = agent_info_ptr->r_uid;
 	task_info_ptr->msg_type          = agent_info_ptr->msg_type;
 	task_info_ptr->msg_args_ptr      = *agent_info_ptr->msg_args_pptr;
 	task_info_ptr->protocol_version  = agent_info_ptr->protocol_version;
@@ -931,6 +942,7 @@ static void *_thread_per_group_rpc(void *args)
 
 	msg.msg_type = msg_type;
 	msg.data     = task_ptr->msg_args_ptr;
+	slurm_msg_set_r_uid(&msg, task_ptr->r_uid);
 
 	if (slurmctld_conf.debug_flags & DEBUG_FLAG_AGENT) {
 		info("%s: sending %s to %s", __func__, rpc_num2string(msg_type),
@@ -1304,6 +1316,8 @@ static void _queue_agent_retry(agent_info_t * agent_info_ptr, int count)
 	agent_arg_ptr->msg_args = *(agent_info_ptr->msg_args_pptr);
 	*(agent_info_ptr->msg_args_pptr) = NULL;
 
+	set_agent_arg_r_uid(agent_arg_ptr, agent_info_ptr->r_uid);
+
 	j = 0;
 	for (i = 0; i < agent_info_ptr->thread_count; i++) {
 		if (!thread_ptr[i].ret_list) {
@@ -2312,3 +2326,10 @@ static void _reboot_from_ctld(agent_arg_t *agent_arg_ptr)
 	}
 	xfree(argv[1]);
 }
+
+/* Set r_uid of agent_arg */
+extern void set_agent_arg_r_uid(agent_arg_t *agent_arg_ptr, uid_t r_uid)
+{
+	agent_arg_ptr->r_uid = r_uid;
+	agent_arg_ptr->r_uid_set = true;
+}
diff --git a/src/slurmctld/agent.h b/src/slurmctld/agent.h
index 2da751b1f6..2da73b0d37 100644
--- a/src/slurmctld/agent.h
+++ b/src/slurmctld/agent.h
@@ -54,6 +54,8 @@ typedef struct agent_arg {
 	uint32_t	node_count;	/* number of nodes to communicate
 					 * with */
 	uint16_t	retry;		/* if set, keep trying */
+	uid_t r_uid;			/* receiver UID */
+	bool r_uid_set;			/* True if receiver UID set*/
 	slurm_addr_t    *addr;          /* if set will send to this
 					   addr not hostlist */
 	hostlist_t	hostlist;	/* hostlist containing the
@@ -114,4 +116,7 @@ extern void mail_job_info(job_record_t *job_ptr, uint16_t mail_type);
 /* Return length of agent's retry_list */
 extern int retry_list_size(void);
 
+/* Set r_uid of agent_arg */
+extern void set_agent_arg_r_uid(agent_arg_t *agent_arg_ptr, uid_t r_uid);
+
 #endif /* !_AGENT_H */
